﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.PDPSimulation.SimulationCore;
using HeuristicLab.Parameters;
using HeuristicLab.Data;
using System.Threading;
using HeuristicLab.Common;
using HeuristicLab.PDPSimulation.DomainModel;

namespace HeuristicLab.PDPSimulation {
  [Item("PickupDeliveryOrderGenerator", "A pickup and delivery order generator.")]
  [StorableClass]
  public abstract class PickupDeliveryOrderGenerator: ParameterizedNamedItem {
    public PickupDeliveryOrderGenerator() : base() {
    }
    [StorableConstructor]
    protected PickupDeliveryOrderGenerator(bool deserializing) : base(deserializing) { }
    protected PickupDeliveryOrderGenerator(PickupDeliveryOrderGenerator original, Cloner cloner)
      : base(original, cloner) {
    }

    public abstract IEnumerable<Order> GetOrders(double timeStart, double timeEnd);
    public abstract bool MoreOrders(double time);
    public abstract double RangeX();
    public abstract double RangeY();
  }
}
